//#include <QFile> //#include <QFileDialog>
#include <QMessageBox>  //#include <QPalette>
#include <QtSql> //#include <QSqlError>
//#include <QTableWidget> //#include <QStringList>
#include "mainwindow.h"
#include "ui_mainwindow.h"

int nInd = 0, nKeyDate, i;
QSqlDatabase db;

MainWindow::MainWindow(QWidget *parent) : QMainWindow(parent), ui(new Ui::MainWindow) {
  ui->setupUi(this);
  ui->dtAdd  -> setDate(QDate::currentDate());
  ui->calDate-> hide(); //QSqlDatabase db;
  db = QSqlDatabase::addDatabase("QSQLITE");
  db.setDatabaseName("DB.s3db");
  if(!db.open()) {
     QMessageBox::warning(this, tr("Error"), "Unable open base DB.db - " + db.lastError().text());
  } //if
  QSqlQuery query;
  if(!query.exec("SELECT object FROM Object ORDER BY object")) {
    QMessageBox::warning(this, "Error", "Unable to select date");
  }
  QStringList obj;
  while (query.next()) {
    obj.append(query.value(0).toString());
  } //while
  ui->cbObj->insertItems(0, obj);

}

MainWindow::~MainWindow() {
    delete ui;
}

void MainWindow::SetParam() {
  QStringList sTable = (QStringList() << "12:35" << "12,4" << "09:45" << "0,345" << "23:54" << "3,45");
  QTableWidget& tbl = *ui->tblData;
  int i, nRow = 3, nCol = 2, nr = 0;
  tbl.setRowCount(3);
  for(nr = 0; nr < nRow; ++nr) {
    for(i = 0; i < nCol; ++i)   {
      QTableWidgetItem *item = new QTableWidgetItem();
      item->setText(sTable[i + nr*nCol]);
      item->setTextAlignment(Qt::AlignHCenter | Qt::AlignVCenter);
      tbl.setItem(nr, i, item);
    }
  }
  ui->cbMode->setCurrentIndex(3);
//  ui->calDate
} // MainWindow::SetParam()


void MainWindow::on_btDate_clicked() {
  ui->calDate->show();
}

void MainWindow::on_calDate_clicked(QDate date) {
  ui->dtAdd->setDate(ui->calDate->selectedDate());
  ui->calDate->hide();
}

void MainWindow::on_btRun_clicked() {
  QSqlQuery query;
  switch(ui->cbMode->currentIndex()) {
    case 0: // Add object
      query.prepare("INSERT INTO Object(object) VALUES(?)");
      query.addBindValue(ui->edAddObj->text());
      if(!query.exec()) {
        QMessageBox::warning(this, "Error", "Unable to insert object");
        return;
      } //if(!query.exec())
      ui->cbObj->insertItem(0, ui->edAddObj->text());
      ui->cbObj->setCurrentIndex(0);
      break;
    case 1: // Add date
      query.prepare("INSERT INTO Date(date) VALUES(?)");
      query.addBindValue(ui->dtAdd->date());
      if(!query.exec()) {
        QMessageBox::warning(this, "Error", "Unable to insert date");
      }
      break;
    case 2: // Add row in table
      ui->tblData->setRowCount(ui->tblData->rowCount() + 10);
      break;
    case 3: // Write table in base
      QSqlQuery query;
      QString qr, dt;
      qr = "SELECT date FROM Date WHERE date = ";
      dt = ui->dtAdd->date().toString("yyyy-MM-dd");
      qr = qr + dt; //     if(!query.exec("SELECT date FROM Date WHERE date = '2010-10-25'")) {
     if(!query.exec(qr)) {
       QMessageBox::warning(this, "Error", "Date not is writed in the base");
       qDebug() << query.lastError();
       return;
     }
     query.first();
     qDebug() << query.next();
     qDebug() << query.value(0);
//      if(nInd != 0) return;
//      ui->tblData->setRowCount(0);
      break;
  }//switch
}//MainWindow::on_btRun_clicked()

void MainWindow::on_tblData_currentCellChanged(int currentRow, int currentColumn, int previousRow, int previousColumn) {
  int nRow = ui->tblData->rowCount();
  int nCol = ui->tblData->columnCount();
  if(nRow==currentRow+1 &&  nCol == currentColumn+1) {
    ui->tblData->insertRow(nRow);
  }
}

